//////////////////////////////////////////////////////////////////////
// scene.cpp: implementation of the scene class.
//
//////////////////////////////////////////////////////////////////////

#include "scene.h"

//////////////////////////////////////////////////////////////////////
// Tu je vsetko co sa kresli
float delta_rot_x=0,delta_rot_y=45.f,delta_rot_z=0.f,rot_y=0.f,rot_x=30.f,rot_z=0.f;
int objekt=0;

void Gula_textur_v_svetlo_1_textura(float gula_polomer,int delenie_guli_sirka,int delenie_guli_dlzka);
static void RotacnaPlocha(int delenie_dlzky,int delenie_uhla);		// vykresli rotacnu plochu okolo osi x

void scene::DrawGLScene()
{
	if(keys['L'] && keys[VK_CONTROL]){ english = !english; keys['L']=0; }
	{
		float pom_fps = fps;
		if(keys[VK_SHIFT])pom_fps *= 2.0f;
		if(keys['W'])delta_rot_x -= 30.0f/pom_fps;
		if(keys['S'])delta_rot_x += 30.0f/pom_fps;
		if(keys['A'])delta_rot_y -= 30.0f/pom_fps;
		if(keys['D'])delta_rot_y += 30.0f/pom_fps;
		if(keys['X'])delta_rot_z -= 30.0f/pom_fps;
		if(keys['E'])delta_rot_z += 30.0f/pom_fps;

		if(keys['W'] && keys['S']){delta_rot_x=0;}
		if(keys['A'] && keys['D']){delta_rot_y=0;}
		if(keys['E'] && keys['X']){delta_rot_z=0;}

		if(keys['R'])
		{
			rot_x = 0;
			rot_y = 0;
			rot_z = 0;
		}

		rot_x += delta_rot_x/fps;
		if(rot_x>360.f)rot_x-=360.f;
		else if(rot_x<0.f)rot_x+=360.f;
		rot_y += delta_rot_y/fps;
		if(rot_y>360.f)rot_y-=360.f;
		else if(rot_y<0.f)rot_y+=360.f;
		rot_z += delta_rot_z/fps;
		if(rot_y>360.f)rot_z-=360.f;
		else if(rot_z<0.f)rot_z+=360.f;

		if(keys[VK_ADD])		dist_glass += 2.f/pom_fps;
		if(keys[VK_SUBTRACT])	dist_glass -= 2.f/pom_fps;
	}

	if(keys['P']){	ciary = !ciary;	keys['P']=0; }
	if(keys['L']){	svetlo = !svetlo; keys['L']=0; }		
	if(ciary)glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
	else	 glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	//cisti buffer v aktualnom viewporte a to iba color a hlbkovy bit
	Prepni_do_3D();
	c->MoveWorld(fps);
	if(keys['U'])
	{
		float k;
		glGetFloatv( GL_MODELVIEW_MATRIX, &mat_glass.m[0][0] );
		mat_glass = invert( mat_glass);
	//	dist_glass = (float )sqrt(c->vp.x * c->vp.x + c->vp.y * c->vp.y + c->vp.z * c->vp.z);
		
		k = 0.08f*dist_glass;
		vertex_glass[0].x = c->vp.x + k*c->vd.x - 0.4f*c->vr.x - 0.4f*c->vu.x;
		vertex_glass[0].y = c->vp.y + k*c->vd.y - 0.4f*c->vr.y - 0.4f*c->vu.y;
		vertex_glass[0].z = c->vp.z + k*c->vd.z - 0.4f*c->vr.z - 0.4f*c->vu.z;
		
		vertex_glass[1].x = c->vp.x + k*c->vd.x + 0.4f*c->vr.x - 0.4f*c->vu.x;
		vertex_glass[1].y = c->vp.y + k*c->vd.y + 0.4f*c->vr.y - 0.4f*c->vu.y;
		vertex_glass[1].z = c->vp.z + k*c->vd.z + 0.4f*c->vr.z - 0.4f*c->vu.z;
		
		vertex_glass[2].x = c->vp.x + k*c->vd.x + 0.4f*c->vr.x + 0.4f*c->vu.x;
		vertex_glass[2].y = c->vp.y + k*c->vd.y + 0.4f*c->vr.y + 0.4f*c->vu.y;
		vertex_glass[2].z = c->vp.z + k*c->vd.z + 0.4f*c->vr.z + 0.4f*c->vu.z;
		
		vertex_glass[3].x = c->vp.x + k*c->vd.x - 0.4f*c->vr.x + 0.4f*c->vu.x;
		vertex_glass[3].y = c->vp.y + k*c->vd.y - 0.4f*c->vr.y + 0.4f*c->vu.y;
		vertex_glass[3].z = c->vp.z + k*c->vd.z - 0.4f*c->vr.z + 0.4f*c->vu.z;
			
		zdroj[0].x = c->vp.x - 0.2f*c->vr.x - 0.2f*c->vu.x;
		zdroj[0].y = c->vp.y - 0.2f*c->vr.y - 0.2f*c->vu.y;
		zdroj[0].z = c->vp.z - 0.2f*c->vr.z - 0.2f*c->vu.z;
		
		zdroj[1].x = c->vp.x + 0.2f*c->vr.x - 0.2f*c->vu.x;
		zdroj[1].y = c->vp.y + 0.2f*c->vr.y - 0.2f*c->vu.y;
		zdroj[1].z = c->vp.z + 0.2f*c->vr.z - 0.2f*c->vu.z;
		
		zdroj[2].x = c->vp.x + 0.2f*c->vr.x + 0.2f*c->vu.x;
		zdroj[2].y = c->vp.y + 0.2f*c->vr.y + 0.2f*c->vu.y;
		zdroj[2].z = c->vp.z + 0.2f*c->vr.z + 0.2f*c->vu.z;
		
		zdroj[3].x = c->vp.x - 0.2f*c->vr.x + 0.2f*c->vu.x;
		zdroj[3].y = c->vp.y - 0.2f*c->vr.y + 0.2f*c->vu.y;
		zdroj[3].z = c->vp.z - 0.2f*c->vr.z + 0.2f*c->vu.z;
		
		light_glass[0] = c->vp.x;
		light_glass[1] = c->vp.y;
		light_glass[2] = c->vp.z;
		light_glass[3] = 1;
	}


	float s_plane[] = { 0.1f, 0.0, -0.5f/dist_glass, 0.0 };
	float t_plane[] = { 0.0, 0.1f, -0.5f/dist_glass, 0.0 };
	float q_plane[] = { 0.0, 0.0,-1./dist_glass, 0.0 };

	glEnable(GL_TEXTURE_GEN_S);
	glEnable(GL_TEXTURE_GEN_T);
	glEnable(GL_TEXTURE_GEN_Q);

	glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR);
	glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR);
	glTexGeni(GL_Q, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR);

	glPushMatrix();
	glMultMatrixf(&mat_glass.m[0][0]);

//	glTranslatef(0,0,dist_glass);
	glTexGenfv(GL_S, GL_EYE_PLANE, s_plane);
	glTexGenfv(GL_T, GL_EYE_PLANE, t_plane);
	glTexGenfv(GL_Q, GL_EYE_PLANE, q_plane);
	glPopMatrix();

	// vykreslime osvetlene svetlom
	glBindTexture( GL_TEXTURE_2D, glass);

	glColor3f(0.8f, 0.8f, 0.8f);
	steny->Render(2);
	if(svetlo) 	
	{
		glLightfv ( GL_LIGHT0, GL_POSITION, light_glass  );		// pozicia difuzneho svetla
		glEnable(GL_LIGHTING);			// zapne svetlo
	}

	glRotatef(rot_x,1,0,0);
	glRotatef(rot_y,0,1,0);
	glRotatef(rot_z,0,0,1);

	switch(objekt)
	{
	case 0:	RotacnaPlocha(20,40); break;
	case 1:	Gula_textur_v_svetlo_1_textura(2.0f,20, 40); break;
	case 2:	
		glColor3f(1,1,1);
		cajnik->Render(2); 
		glColor3f(1,1,1);
		break;
	case 3: _6kriz->Render(2); break;
	case 4:	mnohosten[0]->Render(2); break;
	case 5:	mnohosten[1]->Render(2); break;
	case 6:	mnohosten[2]->Render(2); break;
	case 7:	mnohosten[3]->Render(2); break;
	case 8:	break;
	}

	glDisable(GL_TEXTURE_GEN_S);
	glDisable(GL_TEXTURE_GEN_T);
	glDisable(GL_TEXTURE_GEN_Q);
	
	// vykreslime vsetko ako obycajne
	glEnable(GL_BLEND);
	glBlendFunc(GL_ONE, GL_ONE);
	glBindTexture( GL_TEXTURE_2D, _6kriz->Textura(0));

	switch(objekt)
	{
	case 0:	RotacnaPlocha(20,40); break;
	case 1:	Gula_textur_v_svetlo_1_textura(2.0f,20, 40); break;
	case 2:	
		glColor3f(1,1,1);
		cajnik->Render(); 
		glColor3f(1,1,1);
		break;
	case 3: _6kriz->Render(); break;
	case 4:	mnohosten[0]->Render(); break;
	case 5:	mnohosten[1]->Render(); break;
	case 6:	mnohosten[2]->Render(); break;
	case 7:	mnohosten[3]->Render(); break;
	case 8:	break;
	}
	
	glDisable(GL_LIGHTING);
	c->d();
	glColor3f(0.5f,0.5f,0.5f);
	steny->Render();
	glColor3f(1,1,1);

	glBindTexture( GL_TEXTURE_2D, glass);
	glBegin(GL_QUADS);
		glTexCoord2f(0,0);glVertex3fv( &vertex_glass[0].x );
		glTexCoord2f(1,0);glVertex3fv( &vertex_glass[1].x );
		glTexCoord2f(1,1);glVertex3fv( &vertex_glass[2].x );
		glTexCoord2f(0,1);glVertex3fv( &vertex_glass[3].x );
	glEnd();
	glBindTexture( GL_TEXTURE_2D, zdroj_svetla);
	glBegin(GL_QUADS);
		glTexCoord2f(0,0);glVertex3fv( &zdroj[0].x );
		glTexCoord2f(1,0);glVertex3fv( &zdroj[1].x );
		glTexCoord2f(1,1);glVertex3fv( &zdroj[2].x );
		glTexCoord2f(0,1);glVertex3fv( &zdroj[3].x );
	glEnd();

	glDisable(GL_BLEND);

	
	Prepni_do_2D();

	if(keys[VK_SPACE])
	{
		objekt++;
		if(objekt==9) objekt=0;
		keys[VK_SPACE]=0;
	}
	else if(keys[VK_BACK])
	{
		objekt--;
		if(objekt==-1) objekt=8;
		keys[VK_BACK]=0;
	}
	
	glColor4f(1,1,1,1);

	font0->Begin();
	fps = 1.0f / timer0.GetTime();
	timer0.Reset();
	fps_counter.GetAvgFps(1.f/fps,0.2f);
	gcvt( (double)fps_counter.avg_fps, 4, text);
	font0->Print(0,0,text,0);
	
	gcvt( (double)dist_glass, 4, text);
	font0->Print(0,1,text,0);

	if(keys['H'])							// zobrazenie helpu
	{
		int i=3;
		glDisable(GL_TEXTURE_2D);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		glColor4f(0,0,0,0.6f);
		glLoadIdentity();
		glBegin(GL_QUADS);
			glVertex2i(0,200);
			glVertex2i(800,200);
			glVertex2i(800,555);
			glVertex2i(0,555);
		glEnd();
		glColor4f(1,1,1,1);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_COLOR);
		glEnable(GL_TEXTURE_2D);

		if(english)
		{
			font0->Print(15,i++,"Program: Projected textures",0);
			glColor3f(0.9f,0.9f,1.0f);
			font0->Print(8,i++,"Programmer: Marek Mizanin - www.mizanin.szm.sk",0);
			glColor3f(1.0f,1.0f,1.0f);
			font0->Print(2,i++,"Controls:",0);
			font0->Print(2,i++,"U - Update, change location light and coloured glass",1);
			font0->Print_scale(2,i++,"+ and - on numeric. - increase and decrease distance coloured glass from light",1,0.9f,1.f);
			font0->Print(2,i++,"space - next object",1);
			font0->Print(2,i++,"backspace - previous object",1);
			i++;
			font0->Print(2,i++,"P - on/off wire frame",1);
			font0->Print(2,i++,"L - on/off lighting",1);
			font0->Print(2,i++,"R - reset camera",1);
			font0->Print(2,i++,"insert, delete - move right and left",1);
			font0->Print(2,i++,"home, end - move up and down",1);
			font0->Print(2,i++,"F1 - toggle between fullscreen and window",1);
			i++;
			font0->Print(2,i++,"AD, WS, EX - rotate objecst in axis x, y, z",1);
			font0->Print(2,i++,"A and simultaneously D - stop rotation x, similarly also for y,z axis",1);
			i++;
			font0->Print(2,i++,"1. row - fps, 2. row - distance coloured glass from light",1);
		}
		else
		{
			font0->Print(15,i++,"Program: Projected textures",0);
			glColor3f(0.9f,0.9f,1.0f);
			font0->Print(8,i++,"Naprogramoval: Marek Mizanin - www.mizanin.szm.sk",0);
			glColor3f(1.0f,1.0f,1.0f);
			font0->Print(2,i++,"Pouzivane klavesy:",0);
			font0->Print(2,i++,"U - Update, zmena polohy svetla a farebneho skla",1);
			font0->Print(2,i++,"+ a - na numer. klav. - zvacsuje a zmensuje vzdialenost farebneho skla od svetla",1);
			font0->Print(2,i++,"medzernik - dalsi objekt",1);
			font0->Print(2,i++,"backspace - predchadzajuci objekt",1);
			i++;
			font0->Print(2,i++,"P - zapne/vypne zobrazovanie ciar",1);
			font0->Print(2,i++,"L - zapne/vypne svetlo",1);
			font0->Print(2,i++,"R - reset kamery",1);
			font0->Print(2,i++,"insert, delete - posuv vpravo a vlavo",1);
			font0->Print(2,i++,"home, end - posuv hore a dole",1);
			font0->Print(2,i++,"F1 - prepina medzi fullscreen a oknom",1);
			i++;
			font0->Print(2,i++,"AD, WS, EX - rotuje objekt podla smerov x, y, z",1);
			font0->Print(2,i++,"A a zaroven D - stop rotacia x, podobne aj pre osi y,z",1);
			i++;
			font0->Print(2,i++,"1. riadok - fps, 2. riadok - vzdialenost farebneho skla od svetla",1);
		}
		font0->Print(2,i++,"H - help",1);
	}
	font0->End();
	if(keys['F']){	SaveScreen();	keys['F']=0;}		// ulozenie obrazovky do raw subora
}

inline void Normalise(XYZ *p)
{
	float length;

	length = (float) sqrt(p->x * p->x + p->y * p->y + p->z * p->z);
	if (length != 0) {
		p->x /= length;
		p->y /= length;
		p->z /= length;
	} else {
		p->x = 0;
		p->y = 0;
		p->z = 0;
	}
}

void Gula_textur_v_svetlo_1_textura(float gula_polomer,int delenie_guli_sirka,int delenie_guli_dlzka)
{
	float	sirka;		// sirka je vo zvislom smere, moze byt severna, alebo juzna
	float	dlzka;		// dlzka je vo vodorovnom smere, moze byt vychodna, alebo zapadna
	int		i_sirka, i_dlzka;	// index sirky a dlzky
	float	u,v0,v1;		// suradnice na texture
	XYZ		b[2],normal;	// suradnice vypocitanych bodov
	double	velkost_casti_sirky,velkost_casti_dlzky;
	double	polomer_pre_sirku0,polomer_pre_sirku1;	// polomer pre danu sirku

	velkost_casti_sirky = 1.0/(double)delenie_guli_sirka;
	velkost_casti_dlzky = 1.0/(double)delenie_guli_dlzka;
	
	for(i_sirka=-delenie_guli_sirka; i_sirka<delenie_guli_sirka; i_sirka++) // ideme od 0 stupnov do < ako 90.0
	{
		sirka = (float)( i_sirka*90.0*velkost_casti_sirky );	// vypocet uhlu pre dany index
		v0 = (float)(0.5*(i_sirka+delenie_guli_sirka)*velkost_casti_sirky);			// vypocet prislusnej texturovej koordinacie
		v1 = (float)(0.5*(i_sirka+delenie_guli_sirka+1)*velkost_casti_sirky);		// dalsia texturova koordinacia

		polomer_pre_sirku0 = gula_polomer*cos(PI180*sirka);
		polomer_pre_sirku1 = gula_polomer*cos(PI180*(sirka+90.0*velkost_casti_sirky));
		b[0].y = (float)( gula_polomer*sin(PI180*sirka) );
		b[1].y = (float)( gula_polomer*sin(PI180*(sirka+90.0*velkost_casti_sirky)) );

		b[0].x = 0.0f;
		b[1].x = 0.0f;

		b[0].z = (float)( polomer_pre_sirku0 );
		b[1].z = (float)( polomer_pre_sirku1 );
		u = 0.0;								// vypocet prislusnej texturovej koordinacie

		glBegin( GL_TRIANGLE_STRIP);			// kreslim pas trojuholnikov
		
		normal = b[0];
		Normalise( &normal);
		glNormal3fv((float*)&normal);
		glTexCoord2f(u,v0);
		glVertex3fv((float*)&b[0]);
		
		normal = b[1];
		Normalise( &normal);
		glNormal3fv((float*)&normal);
		glTexCoord2f(u,v1);
		glVertex3fv((float*)&b[1]);

		for(i_dlzka=1; i_dlzka<=delenie_guli_dlzka; i_dlzka++) // ideme od o jeden viac ako 0 stupnov po 90.0
		{
			dlzka = (float)( i_dlzka*360.0*velkost_casti_dlzky );	// vypocet uhlu pre dany index
			u = (float)( i_dlzka*velkost_casti_dlzky );				// vypocet prislusnej texturovej koordinacie

			b[0].x = (float)( polomer_pre_sirku0*sin(PI180*dlzka) );
			b[1].x = (float)( polomer_pre_sirku1*sin(PI180*dlzka) );

			b[0].z = (float)( polomer_pre_sirku0*cos(PI180*dlzka) );
			b[1].z = (float)( polomer_pre_sirku1*cos(PI180*dlzka) );

			normal = b[0];
			Normalise( &normal);
			glNormal3fv((float*)&normal);
			glTexCoord2f(u,v0);
			glVertex3fv((float*)&b[0]);
			
			normal = b[1];
			Normalise( &normal);
			glNormal3fv((float*)&normal);
			glTexCoord2f(u,v1);
			glVertex3fv((float*)&b[1]);
		}
		glEnd();
	}
}

static inline void RiadiacaKrivka(float t,float *bod)			// t je z intervalu 0 <= t <= 1
{
	bod[2]=0;
								// anuloid
	t = t * 360 * PI180;			// 0 <= t <= 2pi
	bod[0] =-(float) cos(t);
	bod[1] = (float) sin(t) + 2;
	bod[2] = 1.f;							// vyskusaj zmenit
}

static void RotacnaPlocha(int delenie_dlzky,int delenie_uhla)		// vykresli rotacnu plochu okolo osi x
{
/*
uhol	t0=				smerovy vektor	t1=				smerovy vektor	t2=
5		bod0[5][]	->	norm0[5][]		bod1[5][]	->	norm1[5][]		bod2[5][]

0		bod0[0][]	->	norm0[0][]		bod1[0][]	->	norm1[0][]		bod2[0][]
1		bod0[1][]	->	norm0[1][]		bod1[1][]	->	norm1[1][]		bod2[1][]
2		bod0[2][]	->	norm0[2][]		bod1[2][]	->	norm1[2][]		bod2[2][]
3		bod0[3][]	->	norm0[3][]		bod1[3][]	->	norm1[3][]		bod2[3][]
4		bod0[4][]	->	norm0[4][]		bod1[4][]	->	norm1[4][]		bod2[4][]
5		bod0[5][]	->	norm0[5][]		bod1[5][]	->	norm1[5][]		bod2[5][]

najprv	vypocitame vsetky body
potom	napr.: z bodov:				vypocitame normalovy vektor prislusneho stvorca
bod0[0][]				bod1[0][]				bod2[0][]
			norm0[0][]				norm1[0][]
bod0[1][]				bod1[1][]				bod2[1][]
			norm0[1][]				norm1[1][]
bod0[2][]				bod1[2][]				bod2[2][]
			norm0[2][]				norm1[2][]
bod0[3][]				bod1[3][]				bod2[3][]

a potom vypocitame vyhladene normalove vektory pre kazdy bod z pola bodov 0 a 1
norm0[0][]				norm1[0][]
			vnorm1[1][]			--	vyhladeny normalovy vektor pre bod1[1][] 
norm0[1][]				norm1[1][]

normalove vektory pre body bod[x][0][] vypocitame :
							norm0[0][]
				vnorm0[1][]			--	vyhladeny normalovy vektor pre bod0[1][] 
							norm0[1][]
*/
	float	(*bod0)[3];		// smernik na pole vrcholov, pricom vrchol ma 3 suradnice (je pole 3 suradnic)
	float	(*bod1)[3];		// -- "" --
	float	(*bod2)[3];		// -- "" --
	float	(*pomocny)[3];	// pomocny smernik pouzity pri vymene smernikov
	float	(*text_x);		// smernika na pole x suradnic textur
	float	text_y[2];		// dve hodnoty y suradnic textur
	float	(*norm0)[3];		// normalovy vektor plochy
	float	(*norm1)[3];
	float	(*vnorm0)[3];		// vyhladeny normalovy vektor plochy
	float	(*vnorm1)[3];
	float	a[3],b[3],absolut;	// a,b - vektory, absolut - absolutna hodnota vektora
	int		i,j=0;				// indexove premenne
	float	uhol;				// uhol zvecsujuci sa v smere pravotocivej skrutky tociacej sa v smere x osi  ( pri normalnom pohlade uhos sa zvecsuje smerum k nam )
	float	t0,t1,t2;			// t - parameter
	float	krivka0[3],krivka1[3],krivka2[3];		// hodnoty vratene funkciou RiadiacaKrivka();
	
	bod0  = new float[delenie_uhla][3];			// alokacia pamete pre pole vrcholov
	bod1  = new float[delenie_uhla][3];
	bod2  = new float[delenie_uhla][3];
	norm0 = new float[delenie_uhla][3];
	norm1 = new float[delenie_uhla][3];
	vnorm0= new float[delenie_uhla][3];
	vnorm1= new float[delenie_uhla][3];
	text_x= new float[delenie_uhla];

	t0 = 0;				// ( (float) j / (float) delenie_dlzky );
	RiadiacaKrivka(t0,krivka0);
	text_y[0]=1-t0;				// parametru t=0 prinalezi vrch obrazka ( suradnica y=1)
	t1 = 1.0f / (float) delenie_dlzky;
	RiadiacaKrivka(t1,krivka1);
	text_y[1]=1-t1;
	t2 = 2.0f / (float) delenie_dlzky;
	RiadiacaKrivka(t2,krivka2);

	for(i=0;i<delenie_uhla;i++)
	{
		uhol = PI180 * 360.0f * ( (float) i / (float) delenie_uhla );
		text_x[i]  = 1.0f - (float) i / (float) delenie_uhla;
		// pre uhol=0 prava strana obrazka, pre zvecsujuci sa uhol postupujeme z pravej strany k lavej, pre uhol=360 lava strana obrazku
		
		// vypocet poli bodov, su to vlastne body na kruznici, pricom bod0 ma nizsiu x suradnicu, bod1 , ma najvecsiu x suradnicu bod2
		bod0[i][0] = krivka0[0];
		bod0[i][1] = krivka0[1] * (float) cos( uhol ) - krivka0[2] * (float) sin( uhol );
		bod0[i][2] = krivka0[1] * (float) sin( uhol ) + krivka0[2] * (float) cos( uhol );

		bod1[i][0] = krivka1[0];
		bod1[i][1] = krivka1[1] * (float) cos( uhol ) - krivka1[2] * (float) sin( uhol );
		bod1[i][2] = krivka1[1] * (float) sin( uhol ) + krivka1[2] * (float) cos( uhol );
		
		bod2[i][0] = krivka2[0];
		bod2[i][1] = krivka2[1] * (float) cos( uhol ) - krivka2[2] * (float) sin( uhol );
		bod2[i][2] = krivka2[1] * (float) sin( uhol ) + krivka2[2] * (float) cos( uhol );
	}

	for(i=0;i<delenie_uhla;i++)		// vypocet normalovych vektorov stvorcov v pase medzi nultov a prvou kruznicou
	{
		if(i == (delenie_uhla-1) )
		{	// vypocet vektora							 bod0[i]   bod1[i]
			a[0] = bod1[0][0] - bod1[i][0];				//	+----->
			a[1] = bod1[0][1] - bod1[i][1];				//	 b    |
			a[2] = bod1[0][2] - bod1[i][2];				//	      |
		}												//	    a v   bod1[i+1]
		else		// bod1[delenie_uhla]=bod1[0];
		{
			a[0] = bod1[i+1][0] - bod1[i][0];
			a[1] = bod1[i+1][1] - bod1[i][1];
			a[2] = bod1[i+1][2] - bod1[i][2];
		}
	
		b[0] = bod1[i][0] - bod0[i][0];
		b[1] = bod1[i][1] - bod0[i][1];
		b[2] = bod1[i][2] - bod0[i][2];
	
		norm0[i][0] = a[1]*b[2] - a[2]*b[1];		// vektorovy sucin vektorov a, b
		norm0[i][1] = a[2]*b[0] - a[0]*b[2];		// vysledok je vektor kolmy na obidve vektory (a,b)
		norm0[i][2] = a[0]*b[1] - a[1]*b[0];		// vysledok je normalovy vektor stvorca bod0[i+1], bod1[i+1], bod1[i], bod0[i]
		// vypocet velkosti vektora
		absolut = (float) sqrt(norm0[i][0]*norm0[i][0]+norm0[i][1]*norm0[i][1]+norm0[i][2]*norm0[i][2]);
		if(absolut>0)		// zabezpecenie proti deleniu nulov
		{
			norm0[i][0] = norm0[i][0]/absolut;		// urobime z normaloveho vektora jednotkovy (z velkostou 1)
			norm0[i][1] = norm0[i][1]/absolut;
			norm0[i][2] = norm0[i][2]/absolut;
		}
	}

	for(i=0;i<delenie_uhla;i++)		// vypocet normalovych vektorov stvorcov v pase medzi prvou a druhou kruznicou
	{
		if(i == (delenie_uhla-1) )
		{	// vypocet vektora					 bod1[i]  bod2[i]
			a[0] = bod1[0][0] - bod1[i][0];		//	+----->
			a[1] = bod1[0][1] - bod1[i][1];		//	|     b
			a[2] = bod1[0][2] - bod1[i][2];		//	|
		}										//	V a -bod1[i+1]
		else
		{
			a[0] = bod1[i+1][0] - bod1[i][0];
			a[1] = bod1[i+1][1] - bod1[i][1];
			a[2] = bod1[i+1][2] - bod1[i][2];
		}
	
		b[0] = bod2[i][0] - bod1[i][0];
		b[1] = bod2[i][1] - bod1[i][1];
		b[2] = bod2[i][2] - bod1[i][2];
	
		norm1[i][0] = a[1]*b[2] - a[2]*b[1];		// vektorovy sucin vektorov a, b
		norm1[i][1] = a[2]*b[0] - a[0]*b[2];		// vysledok je vektor kolmy na obidve vektory (a,b)
		norm1[i][2] = a[0]*b[1] - a[1]*b[0];		// vysledok je normalovy vektor stvorca bod1[i+1], bod2[i+1], bod2[i], bod1[i]
		// vypocet velkosti vektora
		absolut = (float) sqrt(norm1[i][0]*norm1[i][0]+norm1[i][1]*norm1[i][1]+norm1[i][2]*norm1[i][2]);
		if(absolut>0)		// zabezpecenie proti deleniu nulov
		{
			norm1[i][0] = norm1[i][0]/absolut;		// urobime z normaloveho vektora jednotkovy (z velkostou 1)
			norm1[i][1] = norm1[i][1]/absolut;
			norm1[i][2] = norm1[i][2]/absolut;
		}
	}

	//  TERAZ vypocitame vyhladene normalove vektory, a to tak, ze vyhladeny vektor pre bod 
	//	medzi styrmi stvorcami vypocitame ako aritmeticky priemer okolitych normalovych vektorov
	//	normalove vektory pre body bod[x][0][] vypocitame :
	//							norm0[0][]
	//				vnorm0[1][]			--	vyhladeny normalovy vektor pre bod0[1][] 
	//							norm0[1][]
	for(i=1;i<delenie_uhla;i++)			// vypocet vyhladenych normalovych vektorov
	{
		vnorm0[i][0]=( norm0[i-1][0] + norm0[i][0] )/3.0f;
		vnorm0[i][1]=( norm0[i-1][1] + norm0[i][1] )/3.0f;
		vnorm0[i][2]=( norm0[i-1][2] + norm0[i][2] -1.0f)/3.0f;
	}
	vnorm0[0][0]=( norm0[delenie_uhla-1][0] + norm0[0][0] )/3.0f;
	vnorm0[0][1]=( norm0[delenie_uhla-1][1] + norm0[0][1] )/3.0f;
	vnorm0[0][2]=( norm0[delenie_uhla-1][2] + norm0[0][2] -1.0f)/3.0f;
/*	for(i=1;i<delenie_uhla;i++)			// vypocet vyhladenych normalovych vektorov
	{
		vnorm0[i][0]=( norm0[i-1][0] + norm0[i][0] )/2.0f;
		vnorm0[i][1]=( norm0[i-1][1] + norm0[i][1] )/2.0f;
		vnorm0[i][2]=( norm0[i-1][2] + norm0[i][2] )/2.0f;
	}
	vnorm0[0][0]=( norm0[delenie_uhla-1][0] + norm0[0][0] )/2.0f;
	vnorm0[0][1]=( norm0[delenie_uhla-1][1] + norm0[0][1] )/2.0f;
	vnorm0[0][2]=( norm0[delenie_uhla-1][2] + norm0[0][2] )/2.0f;
*/
	//	norm0[0][]				norm1[0][]
	//				vnorm1[1][]			--	vyhladeny normalovy vektor pre bod1[1][] 
	//	norm0[1][]				norm1[1][]
	for(i=1;i<delenie_uhla;i++)			// vypocet vyhladenych normalovych vektorov
	{
		vnorm1[i][0]=( norm0[i-1][0] + norm0[i][0] + norm1[i-1][0] + norm1[i][0] )/4.0f;
		vnorm1[i][1]=( norm0[i-1][1] + norm0[i][1] + norm1[i-1][1] + norm1[i][1] )/4.0f;
		vnorm1[i][2]=( norm0[i-1][2] + norm0[i][2] + norm1[i-1][2] + norm1[i][2] )/4.0f;
	}
	vnorm1[0][0]=( norm0[delenie_uhla-1][0] + norm0[0][0] + norm1[delenie_uhla-1][0] + norm1[0][0] )/4.0f;
	vnorm1[0][1]=( norm0[delenie_uhla-1][1] + norm0[0][1] + norm1[delenie_uhla-1][1] + norm1[0][1] )/4.0f;
	vnorm1[0][2]=( norm0[delenie_uhla-1][2] + norm0[0][2] + norm1[delenie_uhla-1][2] + norm1[0][2] )/4.0f;

	glBegin(GL_QUADS);			// kreslime stvorce
	for(i=0;i<(delenie_uhla-1);i++)		// kresime prvy pas stvorcov z lava
	{

		glNormal3fv( vnorm0[i+1] );				// normalovy vektor pre prvy bod v stvorci
		glTexCoord2f(text_x[i+1],text_y[0]);	// texturove suradnice pre prvy bod v stvorci
		glVertex3fv(   bod0[i+1] );				// prvy bod v stvorci - je v lavo dolnom rohu stvorca 
		glNormal3fv( vnorm1[i+1] );				// normala pre 2. bod
		glTexCoord2f(text_x[i+1],text_y[1]);	// suradnice na texture, ktore sa maju zobrazit na 2. bod
		glVertex3fv(   bod1[i+1] );				// druhy bod - je v pravom dolnom rohu stvorca
		glNormal3fv( vnorm1[i] );				// normalovy vektor pre 3. bod
		glTexCoord2f(text_x[i],text_y[1]);		// suredniece textury, ktore sa zobrazia na 3. bod
		glVertex3fv(   bod1[i] );				// treti bod - je v pravom hornom (vrchnom) rohu stvorca
		glNormal3fv( vnorm0[i] );				// normalovy v
		glTexCoord2f(text_x[i],text_y[0]);		// suradnice textury
		glVertex3fv(   bod0[i] );				// stvrty bod - je v lavom hornom bode stvorca
	}
	glNormal3fv( vnorm0[0] );					// posledny stvorec ktoreho suradnice su na zaciatku t.j. ako pre uhol=0
	glTexCoord2f( 0,text_y[0]);
	glVertex3fv(   bod0[0] );					// suradnice 0 teho bodu: bod0[delenie_uhla] = bod0[0]
	glNormal3fv( vnorm1[0] );
	glTexCoord2f( 0,text_y[1]);
	glVertex3fv(   bod1[0] );					// suradnice dolneho praceho bodu
	glNormal3fv( vnorm1[delenie_uhla-1] );
	glTexCoord2f(text_x[delenie_uhla-1],text_y[1]);
	glVertex3fv(   bod1[delenie_uhla-1] );		// suradnice posledneho bodu v pravo (hore vpravo na texture)
	glNormal3fv( vnorm0[delenie_uhla-1] );
	glTexCoord2f(text_x[delenie_uhla-1],text_y[0]);
	glVertex3fv(   bod0[delenie_uhla-1] );		// suradnice posledneho bodu v lavo (hore vpravo na texture )
	//glEnd();
	
	// TERAZ vypocitame a nakreslime vsetky pasy okrem posledneho
	for(j=1;j<(delenie_dlzky-1);j++)
	{
		t0 = ( (float) j / (float) delenie_dlzky );
		text_y[0]=1-t0;					// vypocet y suradnice na texture
		t1 = ( (float) (j+1) / (float) delenie_dlzky );
		text_y[1]=1-t1;					// vypocet y suradnice na texture
		t2 = ( (float) (j+2) / (float) delenie_dlzky );
		RiadiacaKrivka(t2,krivka2);
	
		// pole bodov 1 a 2 z predchadzajuceho vypoctu su take iste ako polia bodov 0 a 1, ktore by sme pocitaly v tomto cykle
		// polia bodov preto posunieme a vypocitame iba pole bodov 2
		pomocny = bod0;
		bod0 = bod1;		// vymena poli vrcholov
		bod1 = bod2;
		bod2 = pomocny;
		for(i=0;i<delenie_uhla;i++)
		{
			uhol = PI180 * 360.0f * ( (float) i / (float) delenie_uhla );

			bod2[i][0] = krivka2[0];
			bod2[i][1] = krivka2[1] * (float) cos( uhol ) - krivka2[2] * (float) sin( uhol );
			bod2[i][2] = krivka2[1] * (float) sin( uhol ) + krivka2[2] * (float) cos( uhol );
		}
		// lavy pas stvorcov, ktorych normalove vektory sme vypocitali v predchadzajucom cykle
		// je taky isty ako pravy pas, preto normalove vektory norm0 nemusime pocitat 
		pomocny = norm0;
		norm0 = norm1;
		norm1 = pomocny;
		for(i=0;i<delenie_uhla;i++)				// vypocet normalovych vektorov
		{
			if(i == (delenie_uhla-1) )
			{	// vypocet vektora					 bod1[i]  bod2[i]
				a[0] = bod1[0][0] - bod1[i][0];		//	+----->
				a[1] = bod1[0][1] - bod1[i][1];		//	|     b
				a[2] = bod1[0][2] - bod1[i][2];		//	|
			}										//	V a -bod1[i+1]
			else
			{
				a[0] = bod1[i+1][0] - bod1[i][0];
				a[1] = bod1[i+1][1] - bod1[i][1];
				a[2] = bod1[i+1][2] - bod1[i][2];
			}
	
			b[0] = bod2[i][0] - bod1[i][0];
			b[1] = bod2[i][1] - bod1[i][1];
			b[2] = bod2[i][2] - bod1[i][2];
		
			norm1[i][0] = a[1]*b[2] - a[2]*b[1];		// vektorovy sucin vektorov a, b
			norm1[i][1] = a[2]*b[0] - a[0]*b[2];		// vysledok je vektor kolmy na obidve vektory (a,b)
			norm1[i][2] = a[0]*b[1] - a[1]*b[0];		// vysledok je normalovy vektor stvorca bod1[i+1], bod2[i+1], bod2[i], bod1[i]
			// vypocet velkosti vektora
			absolut = (float) sqrt(norm1[i][0]*norm1[i][0]+norm1[i][1]*norm1[i][1]+norm1[i][2]*norm1[i][2]);
			if(absolut>0)		// zabezpecenie proti deleniu nulov
			{
				norm1[i][0] = norm1[i][0]/absolut;		// urobime z normaloveho vektora jednotkovy (z velkostou 1)
				norm1[i][1] = norm1[i][1]/absolut;
				norm1[i][2] = norm1[i][2]/absolut;
			}
		}
		pomocny = vnorm0;	// vypocet vyhladenych normalovych vektorov pre body bod0[i] nemusime pocitat, lebo su to tie iste ako v predchadzajucom kroku pre body bod[1][i]
		vnorm0 = vnorm1;	// lebo su to tie iste ako v predchadzajucom kroku pre body bod[1][i]
		vnorm1 = pomocny;
		for(i=1;i<delenie_uhla;i++)			// vypocet vyhladenych normalovych vektorov
		{
			vnorm1[i][0]=( norm0[i-1][0] + norm0[i][0] + norm1[i-1][0] + norm1[i][0] )/4.0f;
			vnorm1[i][1]=( norm0[i-1][1] + norm0[i][1] + norm1[i-1][1] + norm1[i][1] )/4.0f;
			vnorm1[i][2]=( norm0[i-1][2] + norm0[i][2] + norm1[i-1][2] + norm1[i][2] )/4.0f;
		}
		vnorm1[0][0]=( norm0[delenie_uhla-1][0] + norm0[0][0] + norm1[delenie_uhla-1][0] + norm1[0][0] )/4.0f;
		vnorm1[0][1]=( norm0[delenie_uhla-1][1] + norm0[0][1] + norm1[delenie_uhla-1][1] + norm1[0][1] )/4.0f;
		vnorm1[0][2]=( norm0[delenie_uhla-1][2] + norm0[0][2] + norm1[delenie_uhla-1][2] + norm1[0][2] )/4.0f;

		//glBegin(GL_QUADS);
		for(i=0;i<(delenie_uhla-1);i++)		// kreslime pas stvorcov zo suradnicami bodov bod0[i] a bod1[i]
		{
			glNormal3fv( vnorm0[i+1] );				// normalovy vektor pre prvy bod v stvorci
			glTexCoord2f(text_x[i+1],text_y[0]);	// texturove suradnice pre prvy bod v stvorci
			glVertex3fv(   bod0[i+1] );				// prvy bod v stvorci - je v lavo dolnom rohu stvorca 
			glNormal3fv( vnorm1[i+1] );				// normala pre 2. bod
			glTexCoord2f(text_x[i+1],text_y[1]);	// suradnice na texture, ktore sa maju zobrazit na 2. bod
			glVertex3fv(   bod1[i+1] );				// druhy bod - je v pravom dolnom rohu stvorca
			glNormal3fv( vnorm1[i] );				// normalovy vektor pre 3. bod
			glTexCoord2f(text_x[i],text_y[1]);		// suredniece textury, ktore sa zobrazia na 3. bod
			glVertex3fv(   bod1[i] );				// treti bod - je v pravom hornom (vrchnom) rohu stvorca
			glNormal3fv( vnorm0[i] );				// normalovy v
			glTexCoord2f(text_x[i],text_y[0]);		// suradnice textury
			glVertex3fv(   bod0[i] );				// stvrty bod - je v lavom hornom bode stvorca
		}
		glNormal3fv( vnorm0[0] );					// posledny stvorec ktoreho suradnice su na zaciatku t.j. ako pre uhol=0
		glTexCoord2f( 0,text_y[0]);
		glVertex3fv(   bod0[0] );					// suradnice 0 teho bodu: bod0[delenie_uhla] = bod0[0]
		glNormal3fv( vnorm1[0] );
		glTexCoord2f( 0,text_y[1]);
		glVertex3fv(   bod1[0] );					// suradnice dolneho praceho bodu
		glNormal3fv( vnorm1[delenie_uhla-1] );
		glTexCoord2f(text_x[delenie_uhla-1],text_y[1]);
		glVertex3fv(   bod1[delenie_uhla-1] );		// suradnice posledneho bodu v pravo (hore vpravo na texture)
		glNormal3fv( vnorm0[delenie_uhla-1] );
		glTexCoord2f(text_x[delenie_uhla-1],text_y[0]);
		glVertex3fv(   bod0[delenie_uhla-1] );		// suradnice posledneho bodu v lavo (hore vpravo na texture )
		//glEnd();
	}

	// TERAZ vypocitame a nakreslime posledny pas stvorcov
	//	normalove vektory pre body bod[x][0][] vypocitame :
	//	norm1[0][]
	//				vnorm0[1][]			--	vyhladeny normalovy vektor pre bod0[1][] 
	//	norm1[1][]
	// vyhladene vektory pre bod1[i] pozname
	pomocny = vnorm0;
	vnorm0 = vnorm1;
	vnorm1 = pomocny;
	for(i=1;i<delenie_uhla;i++)			// vypocet vyhladenych normalovych vektorov pre body bod2[i]
	{
		vnorm1[i][0]=( norm1[i-1][0] + norm1[i][0] )/3.0f;
		vnorm1[i][1]=( norm1[i-1][1] + norm1[i][1] )/3.0f;
		vnorm1[i][2]=( norm1[i-1][2] + norm1[i][2] -1.0f)/3.0f;
	}
	vnorm1[0][0]=( norm1[delenie_uhla-1][0] + norm1[0][0] )/3.0f;
	vnorm1[0][1]=( norm1[delenie_uhla-1][1] + norm1[0][1] )/3.0f;
	vnorm1[0][2]=( norm1[delenie_uhla-1][2] + norm1[0][2] -1.0f)/3.0f;
/*	for(i=1;i<delenie_uhla;i++)			// vypocet vyhladenych normalovych vektorov pre body bod2[i]
	{
		vnorm1[i][0]=( norm1[i-1][0] + norm1[i][0] )/2.0f;
		vnorm1[i][1]=( norm1[i-1][1] + norm1[i][1] )/2.0f;
		vnorm1[i][2]=( norm1[i-1][2] + norm1[i][2] )/2.0f;
	}
	vnorm1[0][0]=( norm1[delenie_uhla-1][0] + norm1[0][0] )/2.0f;
	vnorm1[0][1]=( norm1[delenie_uhla-1][1] + norm1[0][1] )/2.0f;
	vnorm1[0][2]=( norm1[delenie_uhla-1][2] + norm1[0][2] )/2.0f;
*/
	//glBegin(GL_QUADS);
	for(i=0;i<(delenie_uhla-1);i++)		// kreslime posledny pas stvorcov, t.j. medzi bodmi bod1[] a bod2[]
	{
		glNormal3fv( vnorm0[i+1] );
		glTexCoord2f(text_x[i+1],text_y[1]);
		glVertex3fv(   bod1[i+1] );
		glNormal3fv( vnorm1[i+1] );
		glTexCoord2f(text_x[i+1],0);
		glVertex3fv(   bod2[i+1] );
		glNormal3fv( vnorm1[i] );
		glTexCoord2f(text_x[i],0);
		glVertex3fv(   bod2[i] );
		glNormal3fv( vnorm0[i] );
		glTexCoord2f(text_x[i],text_y[1]);
		glVertex3fv(   bod1[i] );
	}
	glNormal3fv( vnorm0[0] );
	glTexCoord2f( 0,text_y[1]);
	glVertex3fv(   bod1[0] );
	glNormal3fv( vnorm1[0] );
	glTexCoord2f( 0,0);
	glVertex3fv(   bod2[0] );
	glNormal3fv( vnorm1[delenie_uhla-1] );
	glTexCoord2f(text_x[delenie_uhla-1],0);
	glVertex3fv(   bod2[delenie_uhla-1] );
	glNormal3fv( vnorm0[delenie_uhla-1] );
	glTexCoord2f(text_x[delenie_uhla-1],text_y[1]);
	glVertex3fv(   bod1[delenie_uhla-1] );
	glEnd();

	delete[] bod0;			// uvolnujeme pamet
	delete[] bod1;
	delete[] bod2;
	delete[] norm0;
	delete[] norm1;
	delete[] vnorm0;
	delete[] vnorm1;
	delete[] text_x;
}



