#ifndef _INIT_H
#define _INIT_H

#include <windows.h>	// hlavikov sbor Windows kninice
#include <stdio.h>		// hlavikov sbor standardneho vstupu a vystupu
#include <gl\gl.h>		// hlavikov sbor OpenGL32 kninice
#include <gl\glu.h>		// hlavikov sbor GLu32 kninice
#include <gl\glaux.h>	// hlavikov sbor GLaux kninice 

typedef struct {float x,y,z;}XYZ;


#define screen_x_font 800			// horizontalne rozlisenie
#define screen_y_font 600			// vertikalne rozlisenie

#define uhol_kamery 45.0f		// uhol kamery vo zvyslom smere
#define blizka_orezavacia_rovina 0.1f
#define vzdialena_orezavacia_rovina 100.0f

extern bool	keys[256];				// pole - prca s klavesnicou
extern bool	fullscreen;				// indiktor pre fullscreen
extern		HDC			hDC;		// privtny GDI Device Context
extern		HWND		hWnd;		// Handle na okno
extern		HINSTANCE	hInstance;	// Intalacia programu
extern int	error;					// ak je 1 nastala chyba a program sa ma ukoncit
extern int	screen_x;				// horizontalne rozlisenie
extern int	screen_y;				// vertikalne rozlisenie
extern int	screen_bit;				// pocet bitov na 1 pixel
extern bool	edge_clamp_supported;
extern int	english;

#endif